<?php
/**
* @package RSForm! Pro
* @copyright (C) 2007-2015 www.rsjoomla.com
* @license GPL, http://www.gnu.org/copyleft/gpl.html
*/

defined('_JEXEC') or die('Restricted access');

require_once JPATH_ADMINISTRATOR.'/components/com_rsform/helpers/fields/textbox.php';
require_once JPATH_ADMINISTRATOR . '/components/com_rsform/helpers/rseventspro.php';

class RSFormProFieldRseprocoupon extends RSFormProFieldTextbox
{
	public function getFormInput()
	{
		return $this->setFieldOutput(parent::getFormInput(), $this->getButtonInput());
	}

	protected function setFieldOutput($input, $button)
	{
		return $input . ' ' . $button;
	}

	protected function getButtonInput()
	{
		$onclick = '';

		if ($event = RSEventsProPaymentHelper::getEvent())
		{
			$onclick = 'onclick="rse_verify_coupon('.$event->id.', document.getElementById(\'RSEProCoupon\').value)"';
		}

		// Refresh
		return '<button type="button" ' . $this->getRefreshAttributes() . ' ' . $onclick . ' aria-label="' . $this->escape(JText::_('PLG_SYSTEM_RSFPRSEVENTSPRO_VERIFY_COUPON')) . '"><i class="fa fa-refresh"></i></button>';
	}

	protected function getRefreshAttributes()
	{
		$attr = array(
			'class="rseventspro-coupon-refresh"'
		);

		return implode(' ', $attr);
	}

	public function getAttributes()
	{
		$attr = parent::getAttributes();

		$attr['onchange'] = RSEventsProPaymentHelper::getOnInputFunction() . '();';

		return $attr;
	}
}