<?php
/**
* @package RSForm! Pro
* @copyright (C) 2007-2015 www.rsjoomla.com
* @license GPL, http://www.gnu.org/copyleft/gpl.html
*/

defined('_JEXEC') or die('Restricted access');

require_once JPATH_ADMINISTRATOR.'/components/com_rsform/helpers/fields/textbox.php';
require_once JPATH_ADMINISTRATOR . '/components/com_rsform/helpers/rseventspro.php';
require_once JPATH_SITE . '/components/com_rseventspro/helpers/rseventspro.php';

class RSFormProFieldRseproemail extends RSFormProFieldTextbox
{
	public function getValue()
	{
		// Default value processing
		if (!isset($this->value[$this->name]))
		{
			return JFactory::getUser()->get('email');
		}

		// Actual value is set, return it
		return $this->value[$this->name];
	}

	public function processValidation($validationType = 'form', $SubmissionId = 0)
	{
		$value = $this->getValue();

		// This field is required
		if (!strlen(trim($value)))
		{
			return false;
		}

		// Must be an email address
		if (!JMailHelper::isEmailAddress($value))
		{
			return false;
		}

		// Skip directory editing since it makes no sense
		if ($validationType == 'directory')
		{
			return true;
		}

		if ($event = RSEventsProPaymentHelper::getEvent())
		{
			$multiplereg = rseventsproHelper::getConfig('multi_registration');

			if ($event->form == $this->formId && !$multiplereg)
			{
				$db 	= JFactory::getDbo();
				$query	= $db->getQuery(true)
					->select('COUNT('.$db->qn('id').')')
					->from($db->qn('#__rseventspro_users'))
					->where($db->qn('ide') . ' = ' . $db->q($event->id))
					->where($db->qn('email').' = '.$db->q($this->getValue()));

				$registered = (int) $db->setQuery($query)->loadResult();

				if ($registered)
				{
					$properties =& RSFormProHelper::getComponentProperties($this->componentId);
					$properties['VALIDATIONMESSAGE'] = JText::_('RSEPRO_REGISTRATION_ERROR5');

					return false;
				}
			}
		}

		return true;
	}
}