<?php
/**
* @package RSForm! Pro
* @copyright (C) 2007-2015 www.rsjoomla.com
* @license GPL, http://www.gnu.org/copyleft/gpl.html
*/

defined('_JEXEC') or die('Restricted access');

require_once JPATH_ADMINISTRATOR . '/components/com_rsform/helpers/field.php';
require_once JPATH_ADMINISTRATOR . '/components/com_rsform/helpers/rseventspro.php';
require_once JPATH_SITE . '/components/com_rseventspro/helpers/rseventspro.php';

class RSFormProFieldRsepropayment extends RSFormProField
{
	public function getPreviewInput()
	{
		return $this->getProperty('CAPTION');
	}
	
	public function getFormInput()
	{
		$config	  = rseventsproHelper::getConfig();
		$viewType = $config->payment_type == 0 ? 'RADIOGROUP' : 'DROPDOWN';
		$out      = '';

		// Emulate the 'ITEMS' property
		$this->data['ITEMS'] = RSEventsProPaymentHelper::getPayments();
		$this->data['ADDITIONALATTRIBUTES'] .= ' onchange="' . RSEventsProPaymentHelper::getOnInputFunction() . '();"';

		$config = array(
			'formId' 			=> $this->formId,
			'componentId' 		=> $this->componentId,
			'data' 				=> $this->data,
			'value' 			=> $this->value,
			'invalid' 			=> $this->invalid,
			'errorClass' 		=> $this->errorClass,
			'fieldErrorClass' 	=> $this->fieldErrorClass
		);

		switch ($viewType)
		{
			case 'DROPDOWN':
				$out = $this->getSelectInput($config);
				break;

			case 'RADIOGROUP':
				$out = $this->getRadioInput($config);
				break;
		}

		return $out;
	}

	protected function getSelectInput($config)
	{
		require_once JPATH_ADMINISTRATOR . '/components/com_rsform/helpers/fields/selectlist.php';

		$field = new RSFormProFieldSelectList($config);

		return str_replace('name="form[RSEProPayment][]"', 'name="form[RSEProPayment]"', $field->output);
	}

	protected function getRadioInput($config)
	{
		require_once JPATH_ADMINISTRATOR . '/components/com_rsform/helpers/fields/radiogroup.php';

		$field = new RSFormProFieldRadioGroup($config);

		return $field->output;
	}

	public function processValidation($validationType = 'form', $SubmissionId = 0)
	{
		// Skip directory editing since it makes no sense
		if ($validationType == 'directory')
		{
			return true;
		}

		$value = $this->getValue();

		return !empty($value);
	}
}