<?php
/**
* @package RSForm! Pro
* @copyright (C) 2007-2015 www.rsjoomla.com
* @license GPL, http://www.gnu.org/copyleft/gpl.html
*/

defined('_JEXEC') or die('Restricted access');

require_once JPATH_ADMINISTRATOR . '/components/com_rsform/helpers/field.php';
require_once JPATH_ADMINISTRATOR . '/components/com_rsform/helpers/rseventspro.php';
require_once JPATH_SITE . '/components/com_rseventspro/helpers/rseventspro.php';

class RSFormProFieldRseprotickets extends RSFormProField
{
	public function getPreviewInput()
	{
		return $this->getProperty('CAPTION');
	}

	public function getFormInput()
	{
		$event = RSEventsProPaymentHelper::getEvent();
		$html  = '';

		if (!$event)
		{
			return $html;
		}

		if ($event->ticketsconfig)
		{
			$name = $this->getName();
			$id   = $this->getId();

			$html .= '<a onclick="RSopenModal();" href="javascript:void(0)"><i class="icon-cart"></i> <span id="rsepro_cart">'.JText::_('COM_RSEVENTSPRO_SELECT_TICKETS').'</span></a>';
			$html .= '<br /> <br /> <span id="rsepro_selected_tickets_view"></span><span id="rsepro_selected_tickets"></span>';
			$html .= '<br /> <span id="paymentinfocontainer" style="display:none;"><span id="paymentinfo"></span></span>';
			$html .= '<span class="rs_clear"></span> <br /> <span id="grandtotalcontainer" style="display:none;">'.JText::_('COM_RSEVENTSPRO_GLOBAL_TOTAL').': <span id="grandtotal"></span></span>';
			$html .= '<input type="hidden" name="from" id="from" value="" />';
			$html .= '<input type="hidden" name="' . $name . '" id="'. $id  .'" value="1" />';
			$html .= '<br />';
		}
		else
		{
			// Emulate the 'ITEMS' property
			$this->data['ITEMS'] = RSEventsProPaymentHelper::getTickets();

			$config = array(
				'formId' 			=> $this->formId,
				'componentId' 		=> $this->componentId,
				'data' 				=> $this->data,
				'value' 			=> $this->value,
				'invalid' 			=> $this->invalid,
				'errorClass' 		=> $this->errorClass,
				'fieldErrorClass' 	=> $this->fieldErrorClass
			);
			
			$multipleTickets = rseventsproHelper::getConfig('multi_tickets','int');

			if ($multipleTickets)
			{
				$addTicket = '<button type="button" ' . $this->getAddTicketButtonAttributes() . ' onclick="rs_add_ticket();">'.JText::_('RSEPRO_SUBSCRIBER_ADD_TICKET').'</button> ';
			}
			else
			{
				$addTicket = '';
			}

			$loader = JHtml::_('image', 'com_rseventspro/loader.gif', '', array('id' => 'rs_loader', 'style' => 'display: none; vertical-align: middle;'), true);

			$html = $this->setFieldOutput($this->getNumberInput($multipleTickets), $this->getNumberSelect($multipleTickets), $this->getSelectInput($config), $addTicket, $loader);

			if ($multipleTickets)
			{
				$html .= '<br /> <br /> <span id="tickets"></span>';
				$html .= '<span id="hiddentickets"></span>';
			}
			else
			{
				$html .= '<br />';
			}

			$html .= '<br /> <span id="paymentinfocontainer" style="display:none;"><span id="paymentinfo"></span></span>';
			$html .= '<span class="rs_clear"></span> <br /> <span id="grandtotalcontainer" style="display:none;">'.JText::_('COM_RSEVENTSPRO_GLOBAL_TOTAL').': <span id="grandtotal"></span></span>';

			$html .= ' <br /> <span id="tdescription"></span>';
			$html .= '<input type="hidden" name="from" id="from" value="" />';
		}

		return $html;
	}

	protected function setFieldOutput($numberInput, $numberSelect, $select, $addTicket, $loader)
	{
		return $numberInput . ' ' . $numberSelect . ' ' . $select . ' ' . $addTicket . ' ' . $loader;
	}

	protected function getNumberInput($multipleTickets)
	{
		return '<input ' . $this->getNumberInputAttributes() . ' type="text" id="numberinp" name="numberinp" value="1" size="3" style="display: none;" onkeyup="this.value=this.value.replace(/[^0-9\.\,]/g, \'\');' . (!$multipleTickets ? ' rsepro_add_single_ticket(this);' : '').'" aria-label="' . $this->escape(JText::_('PLG_SYSTEM_RSFPRSEVENTSPRO_TYPE_NUMBER_OF_TICKETS')) . '" />';
	}

	protected function getNumberInputAttributes()
	{
		$attr = array(
			'class="rseventspro-tickets-number-input"'
		);

		return implode(' ', $attr);
	}

	protected function getNumberSelect($multipleTickets)
	{
		return '<select '. $this->getNumberSelectAttributes() .' name="number" id="number"' . (!$multipleTickets ? ' onchange="rsepro_add_single_ticket(this);" ' : '') . 'aria-label="' . $this->escape(JText::_('PLG_SYSTEM_RSFPRSEVENTSPRO_SELECT_NUMBER_OF_TICKETS')) . '"><option value="1">1</option></select>';
	}

	protected function getNumberSelectAttributes()
	{
		$attr = array(
			'class="rseventspro-tickets-number-select"'
		);

		return implode(' ', $attr);
	}

	protected function getAddTicketButtonAttributes()
	{
		$attr = array(
			'class="rseventspro-add-ticket-button"'
		);

		return implode(' ', $attr);
	}

	protected function getSelectInput($config)
	{
		require_once JPATH_ADMINISTRATOR . '/components/com_rsform/helpers/fields/selectlist.php';

		$field = new RSFormProFieldSelectList($config);

		return str_replace('name="form[RSEProTickets][]"', 'name="form[RSEProTickets]"', $field->output);
	}

	public function processValidation($validationType = 'form', $SubmissionId = 0)
	{
		// Skip directory editing since it makes no sense
		if ($validationType == 'directory')
		{
			return true;
		}

		if ($event = RSEventsProPaymentHelper::getEvent())
		{
			$db = JFactory::getDbo();
			$query = $db->getQuery(true)
				->select('COUNT('.$db->qn('id').')')
				->from($db->qn('#__rseventspro_tickets'))
				->where($db->qn('ide').' = '.$db->q($event->id));
			if ($eventtickets = (int) $db->setQuery($query)->loadResult())
			{
				if ($event->ticketsconfig)
				{
					$tickets 	= JFactory::getApplication()->input->get('tickets', array(),'array');
					$unlimited	= JFactory::getApplication()->input->get('unlimited', array(),'array');
					$thetickets = array_merge($tickets, $unlimited);

					if (empty($thetickets))
					{
						return false;
					}
				}
				elseif (rseventsproHelper::getConfig('multi_tickets'))
				{
					$tickets = JFactory::getApplication()->input->get('tickets', array(),'array');

					if (empty($tickets))
					{
						return false;
					}
				}
			}
		}

		return true;
	}
}