<?php
/**
 * @package RSForm! Pro
 * @copyright (C) 2007-2015 www.rsjoomla.com
 * @license GPL, http://www.gnu.org/copyleft/gpl.html
 */

defined('_JEXEC') or die;

abstract class RSEventsProPaymentHelper
{
	public static function getOnInputFunction()
	{
		if ($event = static::getEvent())
		{
			if ($event->ticketsconfig)
			{
				return 'rsepro_update_total';
			}
		}

		return 'rse_calculatetotal';
	}

	public static function getEvent()
	{
		static $event;

		if ($event === null)
		{
			$db = JFactory::getDbo();
			$id	= JFactory::getApplication()->input->getInt('id',0);
			$id	= is_array($id) ? $id[0] : $id;

			$query = $db->getQuery(true)
				->select($db->qn('id'))
				->select($db->qn('name'))
				->select($db->qn('ticketsconfig'))
				->select($db->qn('form'))
				->from($db->qn('#__rseventspro_events'))
				->where($db->qn('id') . ' = ' . $db->q($id));

			$event = $db->setQuery($query)->loadObject();

			if ($event && $event->ticketsconfig && rseventsproHelper::validWaitingList($id))
			{
				$event->ticketsconfig = false;
			}
		}

		return $event;
	}

	public static function getPayments()
	{
		if (JFactory::getApplication()->input->get('option') != 'com_rseventspro' || JFactory::getApplication()->input->get('layout') != 'subscribe')
		{
			return '';
		}

		$cid		= JFactory::getApplication()->input->getInt('cid');
		$db		    = JFactory::getDbo();
		$payments	= array();

		$query = $db->getQuery(true)
			->select($db->qn('payments'))
			->from($db->qn('#__rseventspro_events'))
			->where($db->qn('id') . ' = ' . $db->q($cid));

		$eventPayments	 = $db->setQuery($query)->loadResult();
		$payment_items	 = rseventsproHelper::getPayments(false, $eventPayments);
		$default_payment = rseventsproHelper::getConfig('default_payment');

		if (!empty($payment_items))
		{
			foreach ($payment_items as $payment)
			{
				$default = $default_payment == $payment->value ? '[c]' : '';
				$payments[] = $payment->value.'|'.$payment->text.$default;
			}
		}

		if (!empty($payments))
		{
			return implode("\n",$payments);
		}

		return '';
	}

	public static function getTickets()
	{
		if (JFactory::getApplication()->input->get('option') != 'com_rseventspro' || JFactory::getApplication()->input->get('layout') != 'subscribe')
		{
			return '';
		}

		$cid	 = JFactory::getApplication()->input->getInt('cid');
		$tickets = rseventsproHelper::getTickets($cid, true);
		$w8list	 = rseventsproHelper::validWaitingList($cid);
		$return  = array();

		if (!empty($tickets))
		{
			foreach ($tickets as $ticket)
			{
				if (!$w8list)
				{
					$checkticket = rseventsproHelper::checkticket($ticket->id);
					if ($checkticket == -1)
					{
						continue;
					}
				}

				$price = $ticket->price > 0 ? ' - '.rseventsproHelper::currency($ticket->price) : ' - '.JText::_('COM_RSEVENTSPRO_GLOBAL_FREE');
				$return[] = $ticket->id.'|'.$ticket->name.$price;
			}
		}

		if (!empty($return))
		{
			return implode("\n",$return);
		}

		return '';
	}
}